diff -ruN vdr-1.7.23/remote.c vdr-1.7.24/remote.c
--- vdr-1.7.23/remote.c	2011-08-15 15:41:40.000000000 +0200
+++ vdr-1.7.24/remote.c	2012-01-16 17:57:00.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 2.4 2011/08/15 13:41:40 kls Exp $
+ * $Id: remote.c 2.5 2012/01/16 16:57:00 kls Exp $
  */
 
 #include "remote.h"
@@ -317,38 +317,38 @@
   if ((key1 = ReadKey()) >= 0) {
      k = key1;
      if (key1 == 0x1B) {
-         // Start of escape sequence
-         if ((key1 = ReadKey()) >= 0) {
-            k <<= 8;
-            k |= key1 & 0xFF;
-            switch (key1) {
-              case 0x4F: // 3-byte sequence
-                   if ((key1 = ReadKey()) >= 0) {
-                      k <<= 8;
-                      k |= key1 & 0xFF;
-                      }
-                   break;
-              case 0x5B: // 3- or more-byte sequence
-                   if ((key1 = ReadKey()) >= 0) {
-                      k <<= 8;
-                      k |= key1 & 0xFF;
-                      switch (key1) {
-                        case 0x31 ... 0x3F: // more-byte sequence
-                        case 0x5B: // strange, may apparently occur
-                             do {
-                                if ((key1 = ReadKey()) < 0)
-                                   break; // Sequence ends here
-                                k <<= 8;
-                                k |= key1 & 0xFF;
-                                } while (key1 != 0x7E);
-                             break;
-                        default: ;
-                        }
-                      }
-                   break;
-              default: ;
-              }
-            }
+        // Start of escape sequence
+        if ((key1 = ReadKey()) >= 0) {
+           k <<= 8;
+           k |= key1 & 0xFF;
+           switch (key1) {
+             case 0x4F: // 3-byte sequence
+                  if ((key1 = ReadKey()) >= 0) {
+                     k <<= 8;
+                     k |= key1 & 0xFF;
+                     }
+                  break;
+             case 0x5B: // 3- or more-byte sequence
+                  if ((key1 = ReadKey()) >= 0) {
+                     k <<= 8;
+                     k |= key1 & 0xFF;
+                     switch (key1) {
+                       case 0x31 ... 0x3F: // more-byte sequence
+                       case 0x5B: // strange, may apparently occur
+                            do {
+                               if ((key1 = ReadKey()) < 0)
+                                  break; // Sequence ends here
+                               k <<= 8;
+                               k |= key1 & 0xFF;
+                               } while (key1 != 0x7E);
+                            break;
+                       default: ;
+                       }
+                     }
+                  break;
+             default: ;
+             }
+           }
         }
      }
   return k;
diff -ruN vdr-1.7.23/svdrp.c vdr-1.7.24/svdrp.c
--- vdr-1.7.23/svdrp.c	2012-01-12 16:02:46.000000000 +0100
+++ vdr-1.7.24/svdrp.c	2012-02-16 13:38:19.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 2.13 2012/01/12 15:02:46 kls Exp $
+ * $Id: svdrp.c 2.15 2012/02/16 12:38:19 kls Exp $
  */
 
 #include "svdrp.h"
@@ -256,8 +256,6 @@
   "    used to easily activate or deactivate a timer.",
   "MOVC <number> <to>\n"
   "    Move a channel to a new position.",
-  "MOVT <number> <to>\n"
-  "    Move a timer to a new position.",
   "NEWC <settings>\n"
   "    Create a new channel. Settings must be in the same format as returned\n"
   "    by the LSTC command.",
@@ -664,12 +662,16 @@
         if (recording) {
            cRecordControl *rc = cRecordControls::GetRecordControl(recording->FileName());
            if (!rc) {
-              if (recording->Delete()) {
-                 Reply(250, "Recording \"%s\" deleted", Option);
-                 ::Recordings.DelByName(recording->FileName());
+              if (!cCutter::Active(recording->FileName())) {
+                 if (recording->Delete()) {
+                    Reply(250, "Recording \"%s\" deleted", Option);
+                    ::Recordings.DelByName(recording->FileName());
+                    }
+                 else
+                    Reply(554, "Error while deleting recording!");
                  }
               else
-                 Reply(554, "Error while deleting recording!");
+                 Reply(550, "Recording \"%s\" is being edited", Option);
               }
            else
               Reply(550, "Recording \"%s\" is in use by timer %d", Option, rc->Timer()->Index() + 1);
@@ -1283,12 +1285,6 @@
      Reply(501, "Missing channel number");
 }
 
-void cSVDRP::CmdMOVT(const char *Option)
-{
-  //TODO combine this with menu action
-  Reply(502, "MOVT not yet implemented");
-}
-
 void cSVDRP::CmdNEWC(const char *Option)
 {
   if (*Option) {
@@ -1632,7 +1628,6 @@
   else if (CMD("MODC"))  CmdMODC(s);
   else if (CMD("MODT"))  CmdMODT(s);
   else if (CMD("MOVC"))  CmdMOVC(s);
-  else if (CMD("MOVT"))  CmdMOVT(s);
   else if (CMD("NEWC"))  CmdNEWC(s);
   else if (CMD("NEWT"))  CmdNEWT(s);
   else if (CMD("NEXT"))  CmdNEXT(s);
diff -ruN vdr-1.7.23/svdrp.h vdr-1.7.24/svdrp.h
--- vdr-1.7.23/svdrp.h	2011-12-04 14:51:44.000000000 +0100
+++ vdr-1.7.24/svdrp.h	2012-02-16 13:37:53.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: svdrp.h 2.1 2011/12/04 13:51:44 kls Exp $
+ * $Id: svdrp.h 2.2 2012/02/16 12:37:53 kls Exp $
  */
 
 #ifndef __SVDRP_H
@@ -71,7 +71,6 @@
   void CmdMODC(const char *Option);
   void CmdMODT(const char *Option);
   void CmdMOVC(const char *Option);
-  void CmdMOVT(const char *Option);
   void CmdNEWC(const char *Option);
   void CmdNEWT(const char *Option);
   void CmdNEXT(const char *Option);
diff -ruN vdr-1.7.23/themes.c vdr-1.7.24/themes.c
--- vdr-1.7.23/themes.c	2011-02-25 15:45:18.000000000 +0100
+++ vdr-1.7.24/themes.c	2012-02-17 14:57:32.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: themes.c 2.1 2011/02/25 14:45:18 kls Exp $
+ * $Id: themes.c 2.2 2012/02/17 13:57:32 kls Exp $
  */
 
 #include "themes.h"
@@ -243,37 +243,35 @@
      cReadDir d(themesDirectory);
      struct dirent *e;
      while ((e = d.Next()) != NULL) {
-           if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
-              if (strstr(e->d_name, SkinName) == e->d_name && e->d_name[strlen(SkinName)] == '-') {
-                 cString FileName = AddDirectory(themesDirectory, e->d_name);
-                 cTheme Theme;
-                 if (Theme.Load(*FileName, true)) {
-                    if (char **NewBuffer = (char **)realloc(names, (numThemes + 1) * sizeof(char *))) {
-                       names = NewBuffer;
-                       names[numThemes] = strdup(Theme.Name());
-                       }
-                    else {
-                       esyslog("ERROR: out of memory");
-                       break;
-                       }
-                    if (char **NewBuffer = (char **)realloc(fileNames, (numThemes + 1) * sizeof(char *))) {
-                       fileNames = NewBuffer;
-                       fileNames[numThemes] = strdup(*FileName);
-                       }
-                    else {
-                       esyslog("ERROR: out of memory");
-                       break;
-                       }
-                    if (char **NewBuffer = (char **)realloc(descriptions, (numThemes + 1) * sizeof(char *))) {
-                       descriptions = NewBuffer;
-                       descriptions[numThemes] = strdup(Theme.Description());
-                       }
-                    else {
-                       esyslog("ERROR: out of memory");
-                       break;
-                       }
-                    numThemes++;
+           if (strstr(e->d_name, SkinName) == e->d_name && e->d_name[strlen(SkinName)] == '-') {
+              cString FileName = AddDirectory(themesDirectory, e->d_name);
+              cTheme Theme;
+              if (Theme.Load(*FileName, true)) {
+                 if (char **NewBuffer = (char **)realloc(names, (numThemes + 1) * sizeof(char *))) {
+                    names = NewBuffer;
+                    names[numThemes] = strdup(Theme.Name());
+                    }
+                 else {
+                    esyslog("ERROR: out of memory");
+                    break;
+                    }
+                 if (char **NewBuffer = (char **)realloc(fileNames, (numThemes + 1) * sizeof(char *))) {
+                    fileNames = NewBuffer;
+                    fileNames[numThemes] = strdup(*FileName);
+                    }
+                 else {
+                    esyslog("ERROR: out of memory");
+                    break;
+                    }
+                 if (char **NewBuffer = (char **)realloc(descriptions, (numThemes + 1) * sizeof(char *))) {
+                    descriptions = NewBuffer;
+                    descriptions[numThemes] = strdup(Theme.Description());
+                    }
+                 else {
+                    esyslog("ERROR: out of memory");
+                    break;
                     }
+                 numThemes++;
                  }
               }
            }
diff -ruN vdr-1.7.23/tools.c vdr-1.7.24/tools.c
--- vdr-1.7.23/tools.c	2012-01-11 12:21:43.000000000 +0100
+++ vdr-1.7.24/tools.c	2012-02-18 16:30:35.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 2.20 2012/01/11 11:21:43 kls Exp $
+ * $Id: tools.c 2.22 2012/02/18 15:30:35 kls Exp $
  */
 
 #include "tools.h"
@@ -384,37 +384,35 @@
         if (d.Ok()) {
            struct dirent *e;
            while ((e = d.Next()) != NULL) {
-                 if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
-                    cString buffer = AddDirectory(FileName, e->d_name);
-                    if (FollowSymlinks) {
-                       struct stat st2;
-                       if (lstat(buffer, &st2) == 0) {
-                          if (S_ISLNK(st2.st_mode)) {
-                             int size = st2.st_size + 1;
-                             char *l = MALLOC(char, size);
-                             int n = readlink(buffer, l, size - 1);
-                             if (n < 0) {
-                                if (errno != EINVAL)
-                                   LOG_ERROR_STR(*buffer);
-                                }
-                             else {
-                                l[n] = 0;
-                                dsyslog("removing %s", l);
-                                if (remove(l) < 0)
-                                   LOG_ERROR_STR(l);
-                                }
-                             free(l);
+                 cString buffer = AddDirectory(FileName, e->d_name);
+                 if (FollowSymlinks) {
+                    struct stat st2;
+                    if (lstat(buffer, &st2) == 0) {
+                       if (S_ISLNK(st2.st_mode)) {
+                          int size = st2.st_size + 1;
+                          char *l = MALLOC(char, size);
+                          int n = readlink(buffer, l, size - 1);
+                          if (n < 0) {
+                             if (errno != EINVAL)
+                                LOG_ERROR_STR(*buffer);
                              }
+                          else {
+                             l[n] = 0;
+                             dsyslog("removing %s", l);
+                             if (remove(l) < 0)
+                                LOG_ERROR_STR(l);
+                             }
+                          free(l);
                           }
-                       else if (errno != ENOENT) {
-                          LOG_ERROR_STR(FileName);
-                          return false;
-                          }
                        }
-                    dsyslog("removing %s", *buffer);
-                    if (remove(buffer) < 0)
-                       LOG_ERROR_STR(*buffer);
+                    else if (errno != ENOENT) {
+                       LOG_ERROR_STR(FileName);
+                       return false;
+                       }
                     }
+                 dsyslog("removing %s", *buffer);
+                 if (remove(buffer) < 0)
+                    LOG_ERROR_STR(*buffer);
                  }
            }
         else {
@@ -442,7 +440,7 @@
      bool empty = true;
      struct dirent *e;
      while ((e = d.Next()) != NULL) {
-           if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..") && strcmp(e->d_name, "lost+found")) {
+           if (strcmp(e->d_name, "lost+found")) {
               cString buffer = AddDirectory(DirName, e->d_name);
               struct stat st;
               if (stat(buffer, &st) == 0) {
@@ -480,24 +478,22 @@
      int size = 0;
      struct dirent *e;
      while (size >= 0 && (e = d.Next()) != NULL) {
-           if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
-              cString buffer = AddDirectory(DirName, e->d_name);
-              struct stat st;
-              if (stat(buffer, &st) == 0) {
-                 if (S_ISDIR(st.st_mode)) {
-                    int n = DirSizeMB(buffer);
-                    if (n >= 0)
-                       size += n;
-                    else
-                       size = -1;
-                    }
+           cString buffer = AddDirectory(DirName, e->d_name);
+           struct stat st;
+           if (stat(buffer, &st) == 0) {
+              if (S_ISDIR(st.st_mode)) {
+                 int n = DirSizeMB(buffer);
+                 if (n >= 0)
+                    size += n;
                  else
-                    size += st.st_size / MEGABYTE(1);
-                 }
-              else {
-                 LOG_ERROR_STR(*buffer);
-                 size = -1;
+                    size = -1;
                  }
+              else
+                 size += st.st_size / MEGABYTE(1);
+              }
+           else {
+              LOG_ERROR_STR(*buffer);
+              size = -1;
               }
            }
      return size;
@@ -567,6 +563,14 @@
   return 0;
 }
 
+off_t FileSize(const char *FileName)
+{
+  struct stat fs;
+  if (stat(FileName, &fs) == 0)
+     return fs.st_size;
+  return -1;
+}
+
 // --- cTimeMs ---------------------------------------------------------------
 
 cTimeMs::cTimeMs(int Ms)
@@ -1320,7 +1324,13 @@
 
 struct dirent *cReadDir::Next(void)
 {
-  return directory && readdir_r(directory, &u.d, &result) == 0 ? result : NULL;
+  if (directory) {
+     while (readdir_r(directory, &u.d, &result) == 0 && result) {
+           if (strcmp(result->d_name, ".") && strcmp(result->d_name, ".."))
+              return result;
+           }
+     }
+  return NULL;
 }
 
 // --- cStringList -----------------------------------------------------------
@@ -1362,16 +1372,14 @@
      struct dirent *e;
      if (d.Ok()) {
         while ((e = d.Next()) != NULL) {
-              if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
-                 if (DirsOnly) {
-                    struct stat ds;
-                    if (stat(AddDirectory(Directory, e->d_name), &ds) == 0) {
-                       if (!S_ISDIR(ds.st_mode))
-                          continue;
-                       }
+              if (DirsOnly) {
+                 struct stat ds;
+                 if (stat(AddDirectory(Directory, e->d_name), &ds) == 0) {
+                    if (!S_ISDIR(ds.st_mode))
+                       continue;
                     }
-                 Append(strdup(e->d_name));
                  }
+              Append(strdup(e->d_name));
               }
         Sort();
         return true;
diff -ruN vdr-1.7.23/tools.h vdr-1.7.24/tools.h
--- vdr-1.7.23/tools.h	2011-12-04 15:48:03.000000000 +0100
+++ vdr-1.7.24/tools.h	2012-02-18 16:29:50.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 2.14 2011/12/04 14:48:03 kls Exp $
+ * $Id: tools.h 2.15 2012/02/18 15:29:50 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -224,6 +224,7 @@
 bool SpinUpDisk(const char *FileName);
 void TouchFile(const char *FileName);
 time_t LastModifiedTime(const char *FileName);
+off_t FileSize(const char *FileName); ///< returns the size of the given file, or -1 in case of an error (e.g. if the file doesn't exist)
 cString WeekDayName(int WeekDay);
 cString WeekDayName(time_t t);
 cString WeekDayNameFull(int WeekDay);
diff -ruN vdr-1.7.23/vdr.c vdr-1.7.24/vdr.c
--- vdr-1.7.23/vdr.c	2011-12-03 16:35:09.000000000 +0100
+++ vdr-1.7.24/vdr.c	2012-02-19 12:37:35.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 2.27 2011/12/03 15:35:09 kls Exp $
+ * $Id: vdr.c 2.29 2012/02/19 11:37:35 kls Exp $
  */
 
 #include <getopt.h>
@@ -569,6 +569,7 @@
 
   // Main program loop variables - need to be here to have them initialized before any EXIT():
 
+  cEpgDataReader EpgDataReader;
   cOsdObject *Menu = NULL;
   int LastChannel = 0;
   int LastTimerChannel = -1;
@@ -633,7 +634,7 @@
         cSchedules::SetEpgDataFileName(AddDirectory(EpgDirectory, EpgDataFileName));
      else
         cSchedules::SetEpgDataFileName(EpgDataFileName);
-     cSchedules::Read();
+     EpgDataReader.Start();
      }
 
   // DVB interfaces:
@@ -1159,7 +1160,6 @@
               }
            switch (state) {
              case osPause:  DELETE_MENU;
-                            cControl::Shutdown(); // just in case
                             if (!cRecordControls::PauseLiveVideo())
                                Skins.Message(mtError, tr("No free DVB device to record!"));
                             break;
